#ifndef CURVTORSCALCULATOR_H
#define CURVTORSCALCULATOR_H

#include <memory>

using namespace std;

class StreamlinePool;

/*!
	this class computes discrete curvature and torsion
 */
class CurvTorsCalculator
{
public:
	static CurvTorsCalculator& instance() {
		static CurvTorsCalculator inst;
		return inst;
	}

	void setStreamlinePool(shared_ptr<StreamlinePool> pool) { _pStreamlines = pool;  }
 
	// compute curvature and torsion. results will be saved in 'curvature' and 'torsion' attributes of each streamline
    void computeDiscreteCurvTors();


private:
	CurvTorsCalculator() {}

    std::shared_ptr<StreamlinePool>  _pStreamlines;
};

#endif // CURVTORSCALCULATOR_H
