#ifndef ENTROPYCALCULATOR_H
#define ENTROPYCALCULATOR_H

#include <memory>

using namespace std;

class StreamlinePool;
class Streamline;

/*! calcuates velocity entropy */
class EntropyCalculator {
public:
	static EntropyCalculator& instance();

	void setStreamlinePool(shared_ptr<StreamlinePool> pool);

	void computeEntropyRatio(shared_ptr<StreamlinePool> pool, unsigned nhs);

	float computeEntropyRatio(int sid, int center, int nhs);

private:
	EntropyCalculator() {}
	~EntropyCalculator() {}

	float computeEntropy_helper(Streamline* stl, unsigned start, unsigned end);

private:
	shared_ptr<StreamlinePool>	_pStreamlines;

};

#endif