#ifndef SEGMENTER_H
#define SEGMENTER_H

#include <memory>
#include "svm.h"
#include "vector_types.h"

#include <vector>

using namespace std;

class StreamlinePool;
template<class T> class Attribute;

class Segmenter {
public:
	static Segmenter& instance() {
		static Segmenter inst;
		return inst;
	}

	void setStreamlinePool(shared_ptr<StreamlinePool> pool) { _pStreamlines = pool;  }

	void segment();

private:
	Segmenter() : _cleanup(true) {}

	bool is_seg_point(int sid, int id, float& margin);

	void clean_up_segmentation(int sid, Attribute<unsigned>* segPoints);

private:
	shared_ptr<StreamlinePool>	_pStreamlines;
	bool						_cleanup;
};

#endif