#ifndef SEGMENTHISTCALCULATOR_H
#define SEGMENTHISTCALCULATOR_H

#include <memory>
#include <vector>

using namespace std;

class StreamlinePool;


/*!
	compute the curvature and torsion histogram
 */
class SegmentHistogramCalculator {
public:
	static SegmentHistogramCalculator& instance() { 
		static SegmentHistogramCalculator inst;
		return inst;
	}

	void setStreamlinePool(shared_ptr<StreamlinePool> pool) { _pStreamlines = pool; }

	void computeHistogram(int sid, int start, int end, vector<float>& hist);

private:
	SegmentHistogramCalculator() : _totalCurvBin(20), _tiotalTorsBin(40) {}

	void computeCurvHistogram(int sid, int start, int end, vector<float>& hist);
	void computeTorsHistogram(int sid, int start, int end, vector<float>& hist);

	void computeHist_helper(vector<float>& data, vector<float>& hist, float bucket_size);

private:
	shared_ptr<StreamlinePool>	_pStreamlines;
	int							_totalCurvBin, _tiotalTorsBin;

};
#endif