#ifndef STREAMLINECLUSTER_H
#define STREAMLINECLUSTER_H

#include <memory>
#include <unordered_map>
#include <vector>
#include <tuple>

using namespace std;

class StreamlinePool;

class StreamlineCluster {

public:
	static StreamlineCluster& instance() {
		static StreamlineCluster inst;
		return inst;
	}


	void setStreamlines(shared_ptr<StreamlinePool> pool) { _pStreamlines = pool;  _preference = 0; clusters.clear(); segments.clear(); segmentClusters.clear(); }

	void cluster();

	void clusterSegments();

	void changeSegmentClusters(int val);

	bool recompute_similarity;
private:
	StreamlineCluster() : _sij(nullptr), _preference(0), recompute_similarity(true) {}
	~StreamlineCluster() {}

	void computeSimilarityMatrix();
	void computeSegmentSimilarityMatrix(const vector<tuple<unsigned, unsigned, unsigned>>& );

public:
	unordered_map<int, vector<int>> clusters;

	vector<tuple<unsigned, unsigned, unsigned>> segments;
	unordered_map<int, vector<int>> segmentClusters;

private:
	shared_ptr<StreamlinePool>	_pStreamlines;
	float						*_sij;
	float						_minSimilarity, _medianSimilarity;
	float						_preference;

};


#endif