#ifndef STREAMLINESIMPLIFIER_H
#define STREAMLINESIMPLIFIER_H

#include "streamlinepool.h"

#include <vector>
using namespace std;

class Streamline;

/*!
	simplifies a streamline
 */
class StreamlineSimplifier {
public:
	static StreamlineSimplifier& instance();

	void simplify(vector<Streamline*>& streamlines, float epsilon = 1.0);
private:
	StreamlineSimplifier() {}
	~StreamlineSimplifier() {}

	void FS(Attribute<unsigned> * indices, const vector<float3>& P);
	bool frechet_distance_less_than_epsilon(const vector<float3>&, int i, int j);

	float	_epsilon;

};

#endif