#ifndef TORTUOSITYCALCULATOR_H
#define TORTUOSITYCALCULATOR_H

#include <memory>

using namespace std;

class StreamlinePool;

class TortuosityCalculator {
public:
	static TortuosityCalculator& instance() {
		static TortuosityCalculator inst;
		return inst;
	}

	void setStreamlinePool(shared_ptr<StreamlinePool> pool) { _pStreamlines = pool; }

	float computeTortuosityRatio(int sid, int center, int nhs);

private:
	shared_ptr<StreamlinePool>	_pStreamlines;

};

#endif