#include "trainingstreamlinepicker.h"
#include "streamlinepool.h"
#include "streamlinecluster.h"


void TrainingStreamlinePicker::setStreamlines(const vector<Streamline*>& streamlines)
{
	reset();
	
	if (streamlines.size() == 1)
		return;

	StreamlineCluster::instance().cluster();
	auto it = StreamlineCluster::instance().clusters.begin();
	for (; it != StreamlineCluster::instance().clusters.end(); ++it)
		_unpickedStreamlines.push_back(streamlines[it->first]);

}

int TrainingStreamlinePicker::pickStreamline()
{
	int id;
	
	id = pickBasedOnSimilarity();

	return id;
}

void TrainingStreamlinePicker::reset()
{
	_unpickedStreamlines.clear();
	_pickedStreamlines.clear();
}

int TrainingStreamlinePicker::pickBasedOnSimilarity()
{
	if (_unpickedStreamlines.empty())
		return -1;
	Streamline* stl = _unpickedStreamlines.back();
	int idx = stl->id;
	_pickedStreamlines.push_back(stl);
	_unpickedStreamlines.pop_back();
	return idx;
}