#ifndef UNITSPHEREPARTITIONER_H
#define UNITSPHEREPARTITIONER_H

#include <vector>
#include "vector_types.h"

class UnitSpherePartitioner
{
public:
	static UnitSpherePartitioner& instance();
	
	int findRegionForVector(const float3& v);

	int                 N;

private:
	UnitSpherePartitioner();

	void partition(int n);

	float sphericalCapArea(float theta);

	float sphericalRadius(float area);

public:
	


private:
	float               theta_c;
	float               delta_F;
	std::vector<int>    m;
	std::vector<float>  theta;
	std::vector<float>  alpha;
};

#endif // UNITSPHEREPARTITIONER_H
